/*
 * Generator for security key.
 */
import java.security.SecureRandom;

import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;
import org.apache.commons.codec.binary.Base64;

public class SecurityKeyGenerator {

    public static String genKey(String randomSeed, String algorithm) throws Exception {
        SecureRandom secureRandom = null;  

        if (randomSeed != null) {
            secureRandom = new SecureRandom(Base64.decodeBase64(randomSeed));
        } else {
            secureRandom = new SecureRandom();
        }
        KeyGenerator kg = KeyGenerator.getInstance(algorithm);
        kg.init(secureRandom);
        SecretKey secretKey = kg.generateKey();
        return Base64.encodeBase64String(secretKey.getEncoded());
    }

    public static void main(String[] args) {
        try{
            String skey = genKey(null, "AES");
            System.out.println("Secret key is:" + skey);
        }catch(Exception e)
        {
            System.out.println("Generate key failed");
            e.printStackTrace();
        }
    }

}
